Global( "ShipId", nil)
Global( "DeviceId", {})
Global( "Device", {})
Global( "Shield", {})
Global( "Shields", {})
Global( "Ship", mainForm:GetChildChecked("MainPanel", false))
Global( "LCannon", Ship:GetChildChecked("LCannon", false):GetWidgetDesc())
Global( "RCannon", Ship:GetChildChecked("RCannon", false):GetWidgetDesc())
Global( "Artillery", Ship:GetChildChecked("Artillery", false):GetWidgetDesc())
Global( "Helm", Ship:GetChildChecked("Helm", false):GetWidgetDesc())
Global( "Turbine", Ship:GetChildChecked("Turbine", false):GetWidgetDesc())
Global( "Motor", Ship:GetChildChecked("Motor", false):GetWidgetDesc())
Global( "Reactor", Ship:GetChildChecked("Reactor", false):GetWidgetDesc())
Global( "Insight", Ship:GetChildChecked("Insight", false))
Global( "TCount", Ship:GetChildChecked("TCount", false))
Global( "TooltipText", Ship:GetChildChecked("Tooltip", false))
Global( "SHUD", userMods.GetGlobalConfigSection("SHUD"))
local SlotBugFix = false

Global("Loc", nil)
Global( "L", {
	[ "eng" ]  = "chest",
	[ "rus" ]  =  "",
	[ "fra" ] = "coffre",
	[ "ger" ] = "truhe",
	[ "jpn" ] = "󕨔",
	[ "br" ]  =  "ba",
})
-------------------------------------------------------------------------------
-- FUNCTION
-------------------------------------------------------------------------------
function ColorCheck( sender, health )
	sender:Show(true)
	if health == 100 then
		sender:SetBackgroundColor(SHUD["100%"])
	elseif health >= 75 then
		sender:SetBackgroundColor(SHUD["80%"])
	elseif health >= 50 then
		sender:SetBackgroundColor(SHUD["60%"])
	elseif health >= 25 then
		sender:SetBackgroundColor(SHUD["40%"])
	elseif health > 0 then
		sender:SetBackgroundColor(SHUD["20%"])
	else
		sender:SetBackgroundColor(SHUD["0%"])
	end
end

function ShieldCheck( side, shield )
	local count
	local color
	if shield == 100 then
		count = 5
		color = "100%"
	elseif shield >= 80 then
		count = 4
		color = "80%"
	elseif shield >= 60 then
		count = 3
		color = "60%"
	elseif shield >= 40 then
		count = 2
		color = "40%"
	elseif shield >= 20 then
		count = 1
		color = "20%"
	else
		count = 0
		color = "0%"
	end
	if count == 0 then
		Shields["Shield"..side..1]:Show(true)
	elseif count >= 1 and count < 5 then
		Shields["Shield"..side..count]:Show(true)
		for i = 1, count do
			Shields["Shield"..side..i]:Show(true)
		end
		for i = count + 1, 5 do
			Shields["Shield"..side..i]:Show(false)
		end
	elseif count == 5 then
		Shields["Shield"..side..count]:GetParent():Show(true)
		for i = 1, count do
			Shields["Shield"..side..i]:Show(true)
		end
	end
	for i = 1, 5 do
		Shields["Shield"..side..i]:SetBackgroundColor(SHUD[color])
	end
end

function GetShipData(trans)
	if trans then
		mainForm:Show(true)
		ShipId = trans
		local tHealthPer
		if transport.GetHealth then
			tHealthPer = math.ceil(transport.GetHealth(trans).value / transport.GetHealth(trans).limit * 100)
		else
			tHealthPer = object.GetHealthInfo(trans).valuePercents
		end
		Ship:GetChildChecked("Ship", false):SetPriority(0)
		ColorCheck( Ship:GetChildChecked("Ship", false), tHealthPer )
		for i = 2, 5 do
			Shield["ShieldSide"..i] = Ship:GetChildChecked("ShieldSide"..i, false)
			Shield["ShieldSide"..i]:SetName("ShieldSide"..i)
			local child = Shield["ShieldSide"..i]:GetChildChecked("Shield"..i, false):GetWidgetDesc()
			for x = 1, 5 do
				if Shields["Shield"..i..x] == nil then
					Shields["Shield"..i..x] = mainForm:CreateWidgetByDesc(child)
					Shield["ShieldSide"..i]:AddChild(Shields["Shield"..i..x])
					local P = Shields["Shield"..i..x]:GetPlacementPlain()
					if i == 2 then
						P.posY = P.posY - (4 * x) + 5
						P.sizeX = P.sizeX + (3 * x)
						P.posX = P.posX - (1.5 * x)
						P.sizeY = P.sizeY + (1 * x) + 5
					elseif i == 3 then
						P.posY = 0 + (1 * x)
						P.sizeX = P.sizeX + (3 * x)
						P.sizeY = P.sizeY + (4 * x) + 5
						P.posX = P.posX - (1.5 * x)
					elseif i == 4 then
						P.posX = P.posX - (4 * x)
						P.sizeY = P.sizeY + (2 * x) + 15
						P.posY = P.posY - (1 * x)
						P.sizeX = P.sizeX + (2 * x)
					elseif i == 5 then
						P.posX = 0 + (2 * x)
						P.sizeY = P.sizeY + (2 * x) + 15
						P.posY = P.posY - (1 * x)
						P.sizeX = P.sizeX + (2 * x)
					end
					Shields["Shield"..i..x]:SetPlacementPlain(P)
				end
			end
			ShieldCheck( i, math.ceil(transport.GetShieldStrength(trans, i).value / transport.GetShieldStrength(trans, i).maxValue * 100))
		end
		local devs = transport.GetDevices(trans)
		local Can = 0
		local Art = 0
		local ECa = 0
		local Hel = 0
		local Tur = 0
		if Device ~= nil then
			DeviceId = {}
			for i, v in Device do
				if v then
					v:DestroyWidget()
				end
			end
		end
		for i, v in devs do
			local name = userMods.FromWString(object.GetName(v))
			local idcheck = nil
			local devtype = device.GetUsableDeviceType(v)
			if devtype == USDEV_BEAM_CANNON then
				Device[name..Art] = mainForm:CreateWidgetByDesc(Artillery)
				Ship:AddChild(Device[name..Art])
				Device[name..Art]:SetName(name..Art)
				local P = Device[name..Art]:GetPlacementPlain()
				P.posY = 65
				if Art == 0 then
					P.posX = 80
				else
					P.posX = 135
				end
				Device[name..Art]:SetPlacementPlain(P)
				idcheck = name..Art
				Art = 1
			elseif devtype == USDEV_CANNON then
				local P
				local slot = device.GetShipSlotInfo(v).interfaceSlot
				local side = device.GetShipSlotInfo(v).side
				if slot <= 4 and side == 4 then
					Device[name..Can] = mainForm:CreateWidgetByDesc(LCannon)
					Ship:AddChild(Device[name..Can])
					P = Device[name..Can]:GetPlacementPlain()
					P.posX = 60
					P.posY = 125 + ((slot - 1) * 28)
				elseif slot <= 4 and side == 5 then
					Device[name..Can] = mainForm:CreateWidgetByDesc(RCannon)
					Ship:AddChild(Device[name..Can])
					P = Device[name..Can]:GetPlacementPlain()
					P.posY = 125 + ((slot - 1) * 28)
					P.posX = 140
				elseif slot > 4 and side == 4 then
					Device[name..Can] = mainForm:CreateWidgetByDesc(LCannon)
					Ship:AddChild(Device[name..Can])
					P = Device[name..Can]:GetPlacementPlain()
					P.posY = 140 + ((8 - slot) * 28)
					P.posX = 75
				elseif slot > 4 and side == 5 then
					Device[name..Can] = mainForm:CreateWidgetByDesc(RCannon)
					Ship:AddChild(Device[name..Can])
					P = Device[name..Can]:GetPlacementPlain()
					if SlotBugFix and slot == 5 then
						P.posY = 140 + ((slot - 4) * 28)
					   SlotBugFix = false
					else
						P.posY = 140 + ((slot - 5) * 28)
						SlotBugFix = true
					end
					P.posX = 125
				end
				Device[name..Can]:SetPlacementPlain(P)
				Device[name..Can]:SetName(name..Can)
				idcheck = name..Can
				Can = Can + 1
			elseif devtype == USDEV_RUDDER then
				Device[name] = mainForm:CreateWidgetByDesc(Helm)
				Ship:AddChild(Device[name])
				Device[name]:SetName(name)
				idcheck = name
			elseif devtype == USDEV_ENGINE_VERTICAL then
				Device[name] = mainForm:CreateWidgetByDesc(Turbine)
				Ship:AddChild(Device[name])
				Device[name]:SetName(name)
				idcheck = name
			elseif devtype == USDEV_ENGINE_HORIZONTAL then
				Device[name] = mainForm:CreateWidgetByDesc(Motor)
				Ship:AddChild(Device[name])
				Device[name]:SetName(name)
				idcheck = name
			elseif devtype == USDEV_REACTOR then
				Device[name] = mainForm:CreateWidgetByDesc(Reactor)
				Ship:AddChild(Device[name])
				Device[name]:SetName(name)
				local id = name
				ColorCheck(Device[id], math.ceil((transport.GetEnergy(trans).limit - transport.GetEnergy(trans).value) / transport.GetEnergy(trans).limit * 100))
				DeviceId[id] = v
				Ship:Show(true)
			end
			if idcheck then
				local dHealthPer
				if transport.GetHealth then
					dHealthPer = math.ceil(device.GetHealth(v).value / device.GetHealth(v).limit * 100)
				else
					dHealthPer = object.GetHealthInfo(v).valuePercents
				end
				ColorCheck(Device[idcheck], dHealthPer)
				DeviceId[idcheck] = v
			end
			Ship:GetChildChecked("Insight", false):SetVal("name", common.FormatInt(transport.GetInsight(ShipId), "%g"))
			local chests = 0
			for i, v in avatar.GetDeviceList() do
				if v and object.GetName(v) then
					local chestname = string.lower(userMods.FromWString(object.GetName(v)))
					if string.find(chestname, L[Loc]) then
						chests = chests + 1
					end
				end
			end
			Ship:GetChildChecked("TCount", false):SetVal("name", common.FormatInt(chests, "%g"))
		end
	else
		mainForm:Show(false)
	end
end

function DeviceHealthChanged( params )
	for i, v in DeviceId do
		if params.id == v then
			local dHealthPer
			if transport.GetHealth then
				dHealthPer = math.ceil(device.GetHealth(v).value / device.GetHealth(v).limit * 100)
			else
				dHealthPer = object.GetHealthInfo(v).valuePercents
			end
			ColorCheck(Device[i], dHealthPer)
		end
	end
end

function ShieldChanged( params )
	if params.id == ShipId then
		ShieldCheck(params.side, math.ceil(transport.GetShieldStrength(params.id, params.side).value / transport.GetShieldStrength(params.id, params.side).maxValue * 100))
	end
end

function ShipHealthChanged( params )
	if params.id == ShipId then
		local tHealthPer
		if transport.GetHealth then
			tHealthPer = math.ceil(transport.GetHealth(params.id).value / transport.GetHealth(params.id).limit * 100)
		else
			tHealthPer = object.GetHealthInfo(params.id).valuePercents
		end
		ColorCheck(Ship:GetChildChecked("Ship", false), tHealthPer)
	end
end

function ReactorChanged( params )
	if params.id == ShipId then
		local devs = transport.GetDevices(ShipId)
		for j, x in devs do
			for z, d in DeviceId do
				if d == x then
					local devtype = device.GetUsableDeviceType(x)
					if devtype == USDEV_REACTOR then
						ColorCheck(Device[z], math.ceil((transport.GetEnergy(ShipId).limit - transport.GetEnergy(ShipId).value) / transport.GetEnergy(ShipId).limit * 100))
					end
				end
			end
		end
	end
end

function EmanChanged( params )
	if params.id == ShipId then
		Ship:GetChildChecked("Insight", false):SetVal("name", common.FormatInt(transport.GetInsight(ShipId), "%g"))
	end
end

function SlashCommand( params )
	if common.IsSubstring(params.text, userMods.ToWString("/shuddnd")) then
		local DragPanel = Ship:GetChildChecked("DragPanel", false)
		DragPanel:Show(not DragPanel:IsVisible())
	elseif common.IsSubstring(params.text, userMods.ToWString("/shudtop")) then
		mainForm:SetPriority(10000)
	end
end

function AvatarShip()
	if unit.GetTransport(avatar.GetId()) then
		local trans = unit.GetTransport(avatar.GetId())
		if transport.CanDrawInterface(trans) then
			GetShipData(trans)
		end
	else
		mainForm:Show(false)
	end
end

function Tooltip(r)
	if r.active then
		for i, v in Device do
			if r.sender == v:GetName() then
				local VT = common.CreateValuedText()
				local dHealthPer
				if transport.GetHealth then
					dHealthPer = math.ceil(device.GetHealth(DeviceId[i]).value / device.GetHealth(DeviceId[i]).limit * 100)
				else
					dHealthPer = object.GetHealthInfo(DeviceId[i]).valuePercents
				end
				VT:SetFormat(userMods.ToWString("<html>"..userMods.FromWString(object.GetName(DeviceId[i])).."<br/>"..dHealthPer.."%</html>"))
				Ship:GetChildChecked("Tooltip", false):SetVal("name", VT)
				Ship:GetChildChecked("Tooltip", false):Show(true)
			end
		end
		for i, v in Shield do
			if r.sender == v:GetName() then
				local side = tonumber(string.sub(r.sender, 11))
				Ship:GetChildChecked("Tooltip", false):SetVal("name", userMods.ToWString(math.ceil(transport.GetShieldStrength(ShipId, side).value / transport.GetShieldStrength(ShipId, side).maxValue * 100).."%"))
				Ship:GetChildChecked("Tooltip", false):Show(true)
			end
		end
	else
		Ship:GetChildChecked("Tooltip", false):Show(false)
	end
end

-- AO game Localization detection by SLA. Version 2011-02-05.
function GetGameLocalization()
	local B = cartographer.GetMapBlocks()
	local T = { rus="\203\232\227\224", eng="Holy Land",
	ger="Heiliges Land", fra="Terre Sacr\233e", br="Terra Sagrada", jpn="\131\74\131\106\131\65" }
	for b in B do for l,t in T do
	if userMods.FromWString( cartographer.GetMapBlockInfo(B [b] ).name ) == t
	then return l end; end end; return "eng"
end

--ADDON MANAGER COOPERATION
function OnEventAMMemUsageRequest() --MEMORY
	userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

function OnScriptToggleUI( params ) --UI TOGGLE
	mainForm:Show( params.visible )
end

function ConfigInitEvent()
	userMods.SendEvent("CONFIG_INIT_EVENT_RESPONSE", { sender = common.GetAddonName() })
end

function ConfigEvent()
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 0, name = "DnD", btnType = "Simple"})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 1, name = "100%", btnType = "Color", color = SHUD["100%"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 2, name = "80%", btnType = "Color", color = SHUD["80%"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 3, name = "60%", btnType = "Color", color = SHUD["60%"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 4, name = "40%", btnType = "Color", color = SHUD["40%"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 5, name = "20%", btnType = "Color", color = SHUD["20%"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 6, name = "0%", btnType = "Color", color = SHUD["0%"]})
	userMods.SendEvent("CONFIG_EVENT_RESPONSE", {NoB = 7, name = "Default", btnType = "Simple"})
end

function ConfigSimple(p)
	if p.name == "DnD" then
		local DragPanel = Ship:GetChildChecked("DragPanel", false)
		DragPanel:Show(not DragPanel:IsVisible())
	else
		ColorSet()
		userMods.SendEvent("CONFIG_CLEAR_BUTTONS", {})
		ConfigEvent()
	end
end

function ConfigColor(p)
	SHUD[p.name] = p.color
	userMods.SetGlobalConfigSection("SHUD", SHUD)
end

function ColorSet()
	SHUD["100%"] = {r = 0.09; g = 0.52; b = 0.95; a = .8}
	SHUD["80%"] = {r = 0.08; g = 0.64; b = 0.18; a = .8}
	SHUD["60%"] = {r = .9; g = .9; b = 0; a = .8}
	SHUD["40%"] = {r = .8; g = 0.35; b = 0.02; a = .8}
	SHUD["20%"] = {r = .9; g = 0.2; b = 0; a = .8}
	SHUD["0%"] = {r = .3; g = .3; b = .3; a = .8}
	userMods.SetGlobalConfigSection("SHUD", SHUD)
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	if not SHUD then
		SHUD = {}
		ColorSet()
	end
	common.RegisterEventHandler( AvatarShip, "EVENT_AVATAR_TRANSPORT_CHANGED" )
	common.RegisterEventHandler( DeviceHealthChanged, "EVENT_DEVICE_HEALTH_CHANGED" )
	common.RegisterEventHandler( ShieldChanged, "EVENT_TRANSPORT_SHIELD_CHANGED" )
	common.RegisterEventHandler( ShipHealthChanged, "EVENT_TRANSPORT_HEALTH_CHANGED" )
	common.RegisterEventHandler( SlashCommand, "EVENT_UNKNOWN_SLASH_COMMAND")
	common.RegisterEventHandler( ReactorChanged, "EVENT_TRANSPORT_ENERGY_CHANGED" )
	common.RegisterEventHandler( EmanChanged, "EVENT_TRANSPORT_INSIGHT_CHANGED" )
-- ADDON MANAGER EVENTS (MEMORY, DND TOGGLE, UI TOGGLE)
	common.RegisterEventHandler( OnEventAMMemUsageRequest, "U_EVENT_ADDON_MEM_USAGE_REQUEST" )
	common.RegisterEventHandler( OnScriptToggleUI, "SCRIPT_TOGGLE_UI" )
	
	common.RegisterEventHandler( ConfigInitEvent, "CONFIG_INIT_EVENT" )
	common.RegisterEventHandler( ConfigEvent, "CONFIG_EVENT_"..common.GetAddonName())
	common.RegisterEventHandler( ConfigColor, "CONFIG_COLOR_"..common.GetAddonName())
	common.RegisterEventHandler( ConfigSimple, "CONFIG_SIMPLE_"..common.GetAddonName())
	
	common.RegisterReactionHandler( Tooltip, "Tooltip" )
	Loc = GetGameLocalization()
	local DragPanel = Ship:GetChildChecked("DragPanel", false)
	DragPanel:SetBackgroundColor({r=0;g=0;b=0;a=.4})
	DnD:Init( 992, DragPanel, Ship, true)
	AvatarShip()
end
--------------------------------------------------------------------------------
common.RegisterEventHandler( Init, "EVENT_AVATAR_CREATED" )
if avatar.IsExist() then
	Init()
end
--------------------------------------------------------------------------------